/*
 *=================================================================
 *     Header of Class Random for random number generation
 *=================================================================
 *     $Log: Random.h,v $
 *     Revision 1.1  2000/02/10 16:14:16  kenji
 *     Initial revision
 *
 *=================================================================
 *     The copyright holder of the following codes is
 *
 *     Kenji HARADA
 *     Graduate School of Infomatics, Kyoto University,
 *     Kyoto 606-8501, Japan
 *     e-mail: harada@acs.i.kyoto-u.ac.jp
 *     home-page: http://www-fcs.acs.i.kyoto-u.ac.jp/~harada/
 *=================================================================
 */
//! id="$Id: Random.h,v 1.1 2000/02/10 16:14:16 kenji Exp $"
//! author="Kenji Harada"

#ifndef _RANDOM_H_
#include <math.h>
#define IPP 521
#define SIZE_SEED IPP
#define IQQ 32
#define IPQ (IPP-IQQ)
typedef unsigned int Rint;

//: 
// ̃NXł͗ln@pĐĂB
// ۂtԖڂ̗X(t)͎vZB<BR>
// X(t) := X(t-32) xor X(t-521)
class Random{
private:
  Rint nrbit,iptr,navr;
  Rint iri[IPP];
  double runit;

private:
  void initialize(Rint irand0,Rint nrbit0);
  //: ݒ
  //!param: irand0 - 521̏l𐶐̂ɗp
  //!param: nrbit0 - ̐xinrbit0rbgj
  // ݒ֐

public:
  Random(Rint *seed,Rint nrbit0);
  //: lƐxw肵 Class Constructor
  // lz seedɊi[Ă521
  // xnrbit0rbg̏lƂăZbgB

  Random(Rint irand0=20000101,Rint nrbit0=32);
  //: Axw肵 Class Constructor
  //  irand0gnrbit0rbg̐x̂߂̏ݒB

  void setSeed(Rint irand0,Rint nrbit0=32);
  //: Axw肵ďݒ
  //!param: irand0 - 521̏l𐶐̂ɗp
  //!param: nrbit0 - ̐xinrbit0rbgj
  // irand0ɐxnrbit0rbgōďݒB

  void setSeed(Rint *seed,Rint nrbit0);
  //: lƐxĐݒ
  //!param: seed - 521̏li[ĂL̈ւ̃|C^
  //!param: nrbit0 - ̐xinrbit0rbgj
  // lz initɊi[Ă521
  // xnrbit0rbg̏lƂăZbgB

  Rint getSeed (Rint *seed);
  //: ݂̗̏lƐxԂ
  //!param: seed - ݂̗̏l(521)i[L̈ւ̃|C^
  // ݂̗̏li521j|C^seed̎wL̈Ɋi[B
  // ɐx̃rbg߂lƂĕԂB

  double Uniform(void);

  Rint Int(Rint);
  //: Ulz (0, 1, .. ,ilimit-1)
  //!param: ilimit - ͈͂̏
  // ߂l 0ȏAilimit̗()ԂB

  Rint Int(void);

  void Uniform(Rint nr,Rint *ir);
  //: Ulz(lz)
  //!param: nr - 闐̌
  //!param: ir - li0ȏA2**nrbit0-1 ji[Ԓnւ̃|C^
  // li0ȏA2**nrbit0-1jnrA|C^ ir̎wԒn珇ԂɊi[B

  void Uniform(Rint nr,double *rx);
  //: lz(lz)
  //!param: nr - 闐̌
  //!param: rx - li0ȏA1ji[Ԓnւ̃|C^
  // li0ȏA1jnrA|C^ rx̎wԒn珇ԂɊi[B

  void Int(Rint nr,Rint *ir,Rint ilimit);
  //: tUlz(lz)
  //!param: nr - 闐̌
  //!param: ir - li0ȏAilimit ji[Ԓnւ̃|C^
  //!param: ilimit - 鐮l̏
  // li0ȏAilimitjnrA|C^ ir̎wԒn珇ԂɊi[B

  double Gauss(){
    double theta;
    theta = 6.283185307179586477*Uniform();
    return sqrt(-2e0*log(1e0-Uniform()))*sin(theta);
  }
  //: Kz

  double Exp(){return -log(1e0-Uniform());}
  //: Kwz

  int Binary(double P){return ((int) (Uniform()/P));}
  //: Qz

  void Perm(Rint, int*);

  void Scramble(Rint, int*);

};

#define _RANDOM_H_
#endif
